"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
require("./prism-markup");
require("./prism-clike");
require("./prism-csharp");
prism_core_1.default.languages.aspnet = prism_core_1.default.languages.extend('markup', {
    'page-directive': {
        pattern: /<%\s*@.*%>/i,
        alias: 'tag',
        inside: {
            'page-directive': {
                pattern: /<%\s*@\s*(?:Assembly|Control|Implements|Import|Master(?:Type)?|OutputCache|Page|PreviousPageType|Reference|Register)?|%>/i,
                alias: 'tag',
            },
            rest: prism_core_1.default.languages.markup.tag.inside,
        },
    },
    directive: {
        pattern: /<%.*%>/i,
        alias: 'tag',
        inside: {
            directive: {
                pattern: /<%\s*?[$=%#:]{0,2}|%>/i,
                alias: 'tag',
            },
            rest: prism_core_1.default.languages.csharp,
        },
    },
});
// Regexp copied from prism-markup, with a negative look-ahead added
prism_core_1.default.languages.aspnet.tag.pattern = /<(?!%)\/?[^\s>\/]+(?:\s+[^\s>\/=]+(?:=(?:("|')(?:\\[\s\S]|(?!\1)[^\\])*\1|[^\s'">=]+))?)*\s*\/?>/i;
// match directives of attribute value foo="<% Bar %>"
prism_core_1.default.languages.insertBefore('inside', 'punctuation', {
    directive: prism_core_1.default.languages.aspnet['directive'],
}, prism_core_1.default.languages.aspnet.tag.inside['attr-value']);
prism_core_1.default.languages.insertBefore('aspnet', 'comment', {
    'asp-comment': {
        pattern: /<%--[\s\S]*?--%>/,
        alias: ['asp', 'comment'],
    },
});
// script runat="server" contains csharp, not javascript
prism_core_1.default.languages.insertBefore('aspnet', prism_core_1.default.languages.javascript ? 'script' : 'tag', {
    'asp-script': {
        pattern: /(<script(?=.*runat=['"]?server['"]?)[^>]*>)[\s\S]*?(?=<\/script>)/i,
        lookbehind: true,
        alias: ['asp', 'script'],
        inside: prism_core_1.default.languages.csharp || {},
    },
});
