"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
require("./prism-clike");
require("./prism-c");
prism_core_1.default.languages.bison = prism_core_1.default.languages.extend('c', {});
prism_core_1.default.languages.insertBefore('bison', 'comment', {
    bison: {
        // This should match all the beginning of the file
        // including the prologue(s), the bison declarations and
        // the grammar rules.
        pattern: /^(?:[^%]|%(?!%))*%%[\s\S]*?%%/,
        inside: {
            c: {
                // Allow for one level of nested braces
                pattern: /%\{[\s\S]*?%\}|\{(?:\{[^}]*\}|[^{}])*\}/,
                inside: {
                    delimiter: {
                        pattern: /^%?\{|%?\}$/,
                        alias: 'punctuation',
                    },
                    'bison-variable': {
                        pattern: /[$@](?:<[^\s>]+>)?[\w$]+/,
                        alias: 'variable',
                        inside: {
                            punctuation: /<|>/,
                        },
                    },
                    rest: prism_core_1.default.languages.c,
                },
            },
            comment: prism_core_1.default.languages.c.comment,
            string: prism_core_1.default.languages.c.string,
            property: /\S+(?=:)/,
            keyword: /%\w+/,
            number: {
                pattern: /(^|[^@])\b(?:0x[\da-f]+|\d+)/i,
                lookbehind: true,
            },
            punctuation: /%[%?]|[|:;\[\]<>]/,
        },
    },
});
