"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
var string = /("|')(?:\\(?:\r\n|[\s\S])|(?!\1)[^\\\r\n])*\1/;
prism_core_1.default.languages.css = {
    comment: /\/\*[\s\S]*?\*\//,
    atrule: {
        pattern: /@[\w-](?:[^;{\s]|\s+(?![\s{]))*(?:;|(?=\s*\{))/,
        inside: {
            rule: /^@[\w-]+/,
            'selector-function-argument': {
                pattern: /(\bselector\s*\(\s*(?![\s)]))(?:[^()\s]|\s+(?![\s)])|\((?:[^()]|\([^()]*\))*\))+(?=\s*\))/,
                lookbehind: true,
                alias: 'selector',
            },
            keyword: {
                pattern: /(^|[^\w-])(?:and|not|only|or)(?![\w-])/,
                lookbehind: true,
            },
        },
    },
    url: {
        // https://drafts.csswg.org/css-values-3/#urls
        pattern: RegExp('\\burl\\((?:' +
            string.source +
            '|' +
            /(?:[^\\\r\n()"']|\\[\s\S])*/.source +
            ')\\)', 'i'),
        greedy: true,
        inside: {
            function: /^url/i,
            punctuation: /^\(|\)$/,
            string: {
                pattern: RegExp('^' + string.source + '$'),
                alias: 'url',
            },
        },
    },
    selector: RegExp('[^{}\\s](?:[^{};"\'\\s]|\\s+(?![\\s{])|' + string.source + ')*(?=\\s*\\{)'),
    string: {
        pattern: string,
        greedy: true,
    },
    property: /(?!\s)[-_a-z\xA0-\uFFFF](?:(?!\s)[-\w\xA0-\uFFFF])*(?=\s*:)/i,
    important: /!important\b/i,
    function: /[-a-z0-9]+(?=\()/i,
    punctuation: /[(){};:,]/,
};
prism_core_1.default.languages.css['atrule'].inside.rest = prism_core_1.default.languages.css;
var markup = prism_core_1.default.languages.markup;
if (markup) {
    markup.tag.addInlined('style', 'css');
    prism_core_1.default.languages.insertBefore('inside', 'attr-value', {
        'style-attr': {
            pattern: /(^|["'\s])style\s*=\s*(?:"[^"]*"|'[^']*')/i,
            lookbehind: true,
            inside: {
                'attr-value': {
                    pattern: /=\s*(?:"[^"]*"|'[^']*'|[^\s'">=]+)/,
                    inside: {
                        style: {
                            pattern: /(["'])[\s\S]+(?=["']$)/,
                            lookbehind: true,
                            alias: 'language-css',
                            inside: prism_core_1.default.languages.css,
                        },
                        punctuation: [
                            {
                                pattern: /^=/,
                                alias: 'attr-equals',
                            },
                            /"|'/,
                        ],
                    },
                },
                'attr-name': /^style/i,
            },
        },
    }, markup.tag);
}
