"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
require("./prism-clike");
require("./prism-ruby");
require("./prism-markup");
require("./prism-markup-templating");
prism_core_1.default.languages.erb = prism_core_1.default.languages.extend('ruby', {});
prism_core_1.default.languages.insertBefore('erb', 'comment', {
    delimiter: {
        pattern: /^<%=?|%>$/,
        alias: 'punctuation',
    },
});
prism_core_1.default.hooks.add('before-tokenize', function (env) {
    var erbPattern = /<%=?(?:[^\r\n]|[\r\n](?!=begin)|[\r\n]=begin\s[\s\S]*?^=end)+?%>/gm;
    prism_core_1.default.languages['markup-templating'].buildPlaceholders(env, 'erb', erbPattern);
});
prism_core_1.default.hooks.add('after-tokenize', function (env) {
    prism_core_1.default.languages['markup-templating'].tokenizePlaceholders(env, 'erb');
});
