"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
require("./prism-clike");
require("./prism-javascript");
prism_core_1.default.languages.flow = prism_core_1.default.languages.extend('javascript', {});
prism_core_1.default.languages.insertBefore('flow', 'keyword', {
    type: [
        {
            pattern: /\b(?:[Nn]umber|[Ss]tring|[Bb]oolean|Function|any|mixed|null|void)\b/,
            alias: 'tag',
        },
    ],
});
prism_core_1.default.languages.flow['function-variable'].pattern = /(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*(?=\s*=\s*(?:function\b|(?:\([^()]*\)(?:\s*:\s*\w+)?|(?!\s)[_$a-z\xA0-\uFFFF](?:(?!\s)[$\w\xA0-\uFFFF])*)\s*=>))/i;
delete prism_core_1.default.languages.flow['parameter'];
prism_core_1.default.languages.insertBefore('flow', 'operator', {
    'flow-punctuation': {
        pattern: /\{\||\|\}/,
        alias: 'punctuation',
    },
});
if (!Array.isArray(prism_core_1.default.languages.flow.keyword)) {
    prism_core_1.default.languages.flow.keyword = [prism_core_1.default.languages.flow.keyword];
}
prism_core_1.default.languages.flow.keyword.unshift({
    pattern: /(^|[^$]\b)(?:type|opaque|declare|Class)\b(?!\$)/,
    lookbehind: true,
}, {
    pattern: /(^|[^$]\B)\$(?:await|Diff|Exact|Keys|ObjMap|PropertyType|Shape|Record|Supertype|Subtype|Enum)\b(?!\$)/,
    lookbehind: true,
});
