"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
require("./prism-markup");
require("./prism-markup-templating");
prism_core_1.default.languages.handlebars = {
    comment: /\{\{![\s\S]*?\}\}/,
    delimiter: {
        pattern: /^\{\{\{?|\}\}\}?$/i,
        alias: 'punctuation',
    },
    string: /(["'])(?:\\.|(?!\1)[^\\\r\n])*\1/,
    number: /\b0x[\dA-Fa-f]+\b|(?:\b\d+(?:\.\d*)?|\B\.\d+)(?:[Ee][+-]?\d+)?/,
    boolean: /\b(?:true|false)\b/,
    block: {
        pattern: /^(\s*(?:~\s*)?)[#\/]\S+?(?=\s*(?:~\s*)?$|\s)/i,
        lookbehind: true,
        alias: 'keyword',
    },
    brackets: {
        pattern: /\[[^\]]+\]/,
        inside: {
            punctuation: /\[|\]/,
            variable: /[\s\S]+/,
        },
    },
    punctuation: /[!"#%&':()*+,.\/;<=>@\[\\\]^`{|}~]/,
    variable: /[^!"#%&'()*+,\/;<=>@\[\\\]^`{|}~\s]+/,
};
prism_core_1.default.hooks.add('before-tokenize', function (env) {
    var handlebarsPattern = /\{\{\{[\s\S]+?\}\}\}|\{\{[\s\S]+?\}\}/g;
    prism_core_1.default.languages['markup-templating'].buildPlaceholders(env, 'handlebars', handlebarsPattern);
});
prism_core_1.default.hooks.add('after-tokenize', function (env) {
    prism_core_1.default.languages['markup-templating'].tokenizePlaceholders(env, 'handlebars');
});
