"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
require("./prism-markup");
require("./prism-markup-templating");
require("./prism-php");
require("./prism-javadoclike");
var typeExpression = /(?:\b[a-zA-Z]\w*|[|\\[\]])+/.source;
prism_core_1.default.languages.phpdoc = prism_core_1.default.languages.extend('javadoclike', {
    parameter: {
        pattern: RegExp('(@(?:global|param|property(?:-read|-write)?|var)\\s+(?:' +
            typeExpression +
            '\\s+)?)\\$\\w+'),
        lookbehind: true,
    },
});
prism_core_1.default.languages.insertBefore('phpdoc', 'keyword', {
    'class-name': [
        {
            pattern: RegExp('(@(?:global|package|param|property(?:-read|-write)?|return|subpackage|throws|var)\\s+)' +
                typeExpression),
            lookbehind: true,
            inside: {
                keyword: /\b(?:callback|resource|boolean|integer|double|object|string|array|false|float|mixed|bool|null|self|true|void|int)\b/,
                punctuation: /[|\\[\]()]/,
            },
        },
    ],
});
prism_core_1.default.languages.javadoclike.addSupport('php', prism_core_1.default.languages.phpdoc);
