"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
prism_core_1.default.languages.smalltalk = {
    comment: /"(?:""|[^"])*"/,
    character: {
        pattern: /\$./,
        alias: 'string',
    },
    string: /'(?:''|[^'])*'/,
    symbol: /#[\da-z]+|#(?:-|([+\/\\*~<>=@%|&?!])\1?)|#(?=\()/i,
    'block-arguments': {
        pattern: /(\[\s*):[^\[|]*\|/,
        lookbehind: true,
        inside: {
            variable: /:[\da-z]+/i,
            punctuation: /\|/,
        },
    },
    'temporary-variables': {
        pattern: /\|[^|]+\|/,
        inside: {
            variable: /[\da-z]+/i,
            punctuation: /\|/,
        },
    },
    keyword: /\b(?:nil|true|false|self|super|new)\b/,
    number: [
        /\d+r-?[\dA-Z]+(?:\.[\dA-Z]+)?(?:e-?\d+)?/,
        /\b\d+(?:\.\d+)?(?:e-?\d+)?/,
    ],
    operator: /[<=]=?|:=|~[~=]|\/\/?|\\\\|>[>=]?|[!^+\-*&|,@]/,
    punctuation: /[.;:?\[\](){}]/,
};
