"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
function createBlock(prefix, inside, contentAlias) {
    return {
        pattern: RegExp('<#' + prefix + '[\\s\\S]*?#>'),
        alias: 'block',
        inside: {
            delimiter: {
                pattern: RegExp('^<#' + prefix + '|#>$'),
                alias: 'important',
            },
            content: {
                pattern: /[\s\S]+/,
                inside: inside,
                alias: contentAlias,
            },
        },
    };
}
function createT4(insideLang) {
    var grammar = prism_core_1.default.languages[insideLang];
    var className = 'language-' + insideLang;
    return {
        block: {
            pattern: /<#[\s\S]+?#>/,
            inside: {
                directive: createBlock('@', {
                    'attr-value': {
                        pattern: /=(?:("|')(?:\\[\s\S]|(?!\1)[^\\])*\1|[^\s'">=]+)/,
                        inside: {
                            punctuation: /^=|^["']|["']$/,
                        },
                    },
                    keyword: /\w+(?=\s)/,
                    'attr-name': /\w+/,
                }),
                expression: createBlock('=', grammar, className),
                'class-feature': createBlock('\\+', grammar, className),
                standard: createBlock('', grammar, className),
            },
        },
    };
}
prism_core_1.default.languages['t4-templating'] = Object.defineProperty({}, 'createT4', {
    value: createT4,
});
