"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prism_core_1 = __importDefault(require("./prism-core"));
prism_core_1.default.languages.turtle = {
    comment: {
        pattern: /#.*/,
        greedy: true,
    },
    'multiline-string': {
        pattern: /"""(?:(?:""?)?(?:[^"\\]|\\.))*"""|'''(?:(?:''?)?(?:[^'\\]|\\.))*'''/,
        greedy: true,
        alias: 'string',
        inside: {
            comment: /#.*/,
        },
    },
    string: {
        pattern: /"(?:[^\\"\r\n]|\\.)*"|'(?:[^\\'\r\n]|\\.)*'/,
        greedy: true,
    },
    url: {
        pattern: /<(?:[^\x00-\x20<>"{}|^`\\]|\\(?:u[\da-fA-F]{4}|U[\da-fA-F]{8}))*>/,
        greedy: true,
        inside: {
            punctuation: /[<>]/,
        },
    },
    function: {
        pattern: /(?:(?![-.\d\xB7])[-.\w\xB7\xC0-\uFFFD]+)?:(?:(?![-.])(?:[-.:\w\xC0-\uFFFD]|%[\da-f]{2}|\\.)+)?/i,
        inside: {
            'local-name': {
                pattern: /([^:]*:)[\s\S]+/,
                lookbehind: true,
            },
            prefix: {
                pattern: /[\s\S]+/,
                inside: {
                    punctuation: /:/,
                },
            },
        },
    },
    number: /[+-]?\b\d+(?:\.\d*)?(?:e[+-]?\d+)?/i,
    punctuation: /[{}.,;()[\]]|\^\^/,
    boolean: /\b(?:true|false)\b/,
    keyword: [/(?:\ba|@prefix|@base)\b|=/, /\b(?:graph|base|prefix)\b/i],
    tag: {
        pattern: /@[a-z]+(?:-[a-z\d]+)*/i,
        inside: {
            punctuation: /@/,
        },
    },
};
prism_core_1.default.languages.trig = prism_core_1.default.languages['turtle'];
